/*//////////////////////////// DOMREADY ////////////////////////////
_______________________________________________________________________________________________________ */

window.addEvent('domready',function() { 	

	// super-parameters-table handler
	if (document.getElement('div.wrpSuperHistoricalAlarmsTable')) { this.mySuperHistoricalAlarmsTable = new superHistoricalAlarmsTable();	}

});	



/*//////////////////////////// CLASSES ////////////////////////////
_______________________________________________________________________________________________________ */


var superHistoricalAlarmsTable = new Class({

    /* ________ TABLE NESTED STRUCTURE - START______________________________________
	
	<div id="" class="wrpSuperHistoricalAlarmsTable">				
	
		<table>			  
	
		  <tr id="rowParX" class="odd|even readonly error">
    <th>
    <input type="checkbox" id="chkParX" value="" />
    <input type="hidden"   id="recParX" value="{recid+group[]+isreadonly+isaddress}" />
    </th>
    <td>...</td>
    <td class="valmin">AAA</td>
    <td class="valmax">BBB ()</td>
    <td class="valpre">CCC</td>
    <td class="valdev">DDD</td>
    <td class="valusr">
    <input type="text" id="valParX" value=""/> or
    <select id="valParX"><option value="True|False">T|F</option></select>
    </td>
    </tr>
	
	___________________________________________________________________________END__ */

    initialize: function() {

        // store behaviour objects
        this.boxWrapper = document.getElement('div.wrpSuperHistoricalAlarmsTable');
        this.rowsAlarms = this.boxWrapper.getElements('tbody tr');

        // init user preferences cookies
        this.adduserpreferences();

        // handle filters & visual helpers
        this.addcontrollers();

        // redraw preferences listing based on cookie-stored or default filter values
        this.redraw_updateListing();

        // stop "wait-loading" procedure
        this.boxWrapper.removeClass('sptWaitLoading');

    },

    adduserpreferences: function() {

        var cookid = getFolding().join('-') + '_usrFilterPrefs';
        this.userprefs = new Hash.Cookie(cookid, { duration: 365 });

    },

    addcontrollers: function() {

        // add listing filters (if they exist)
        if (document.getElement('.wkaFilterArea #shatFilterShow_inpAlrDevice')) { this.addcontrol('filter_by_device'); }
        if (document.getElement('.wkaFilterArea #shatFilterShow_inpAlrResource')) { this.addcontrol('filter_by_resource'); }

        // add visual helpers (if they exist)
        if (document.getElement('.wkaContentArea #shatVisualShow_Suppression')) { this.addcontrol('visual_suppression'); }

        // add global filter clearer (if exists)
        if (document.getElement('.wkaToolbarArea a.watGridClearFilter')) { document.getElement('.wkaToolbarArea a.watGridClearFilter').addEvent('click', this.toolbar_exeClearFilter.bindWithEvent(this)); }
    },

    addcontrol: function(knd) {

        switch (knd) {

            case 'filter_by_device':
                // handle alarm device input field
                $('shatFilterShow_inpAlrDevice').addEvent('keyup', this.redraw_delayedListing.pass(500, this));
                $('shatFilterShow_inpAlrDevice').addEvent('change', this.redraw_delayedListing.pass(500, this));
                // load saved state
                if (this.userprefs.get('shatFilterShow_inpAlrDevice') != null) { $('shatFilterShow_inpAlrDevice').value = this.userprefs.get('shatFilterShow_inpAlrDevice'); }
                // conditional reference to be used later
                this.filter_by_device = true;
                break;

            case 'filter_by_resource':
                // handle alarm resource input field
                $('shatFilterShow_inpAlrResource').addEvent('keyup', this.redraw_delayedListing.pass(500, this));
                $('shatFilterShow_inpAlrResource').addEvent('change', this.redraw_delayedListing.pass(500, this));
                // load saved state
                if (this.userprefs.get('shatFilterShow_inpAlrResource') != null) { $('shatFilterShow_inpAlrResource').value = this.userprefs.get('shatFilterShow_inpAlrResource'); }
                // conditional reference to be used later
                this.filter_by_resource = true;
                break;

            case 'visual_suppression':
                // conditional reference to be used later
                this.visual_suppression = true;
                break;

        }

    },

    helper_togSuppression: function(bol) {

        // toggle table caption visibility
        $('shatVisualShow_Suppression').setStyle('display', bol ? '' : 'none');

    },

    toolbar_exeClearFilter: function(event) {

        var event = new Event(event);

        // reset form controls values on filter area
        document.getElement('.wkaFilterArea').resetFormElements('restore');

        // redraw network listing
        this.redraw_updateListing();

        // clear & re-initialize cookie
        this.userprefs.empty();
        this.adduserpreferences();

        // prevent default action
        event.preventDefault();
    },

    redraw_updateListing: function() {

        // reset row suppression
        this.boxWrapper.getElements('tr.suppressed').each(function(crw) { crw.removeClass('suppressed'); crw.suppressed = false; });

        // filter on alarm device
        if (this.filter_by_device) {

            var cdev = $('shatFilterShow_inpAlrDevice').get('value').toLowerCase();
            var crfd = $('shatFilterShow_refAlrDevice').get('value').toInt();

            // store user preferences in a cookie
            this.userprefs.extend({ 'shatFilterShow_inpAlrDevice': cdev });

        }

        // filter on alarm resource
        if (this.filter_by_resource) {

            var cres = $('shatFilterShow_inpAlrResource').get('value').toLowerCase();
            var crfr = $('shatFilterShow_refAlrResource').get('value').toInt();

            // store user preferences in a cookie
            this.userprefs.extend({ 'shatFilterShow_inpAlrResource': cres });

        }

        // multiple boolean <&&> filter on rows
        this.rowsAlarms.each(function(crw) {

            if (crw.cells.length > crfd - 1) {
                if (this.filter_by_device && (cdev != '' && !$(crw.cells[crfd - 1]).get('text').toLowerCase().test(cdev))) {
                    crw.addClass('suppressed'); crw.suppressed = true;
                }
            }

            if (crw.cells.length > crfr - 1) {
                // Tests both by alarm code (column crfr-1) and alarm name (column crfr).
                if (this.filter_by_resource &&
                    (cres != '' && !$(crw.cells[crfr - 1]).get('text').toLowerCase().test(cres)) &&
                        (cres != '' && !$(crw.cells[crfr]).get('text').toLowerCase().test(cres))) {
                    crw.addClass('suppressed');
                    crw.suppressed = true;
                }
            }

        }, this);

        // show table caption on row suppression
        if (this.visual_suppression) { this.helper_togSuppression(this.boxWrapper.getElements('tr.suppressed').length > 0); }

    },

    redraw_delayedListing: function(delay) {

        // better use a timeout to handle multiple update sequences
        timedelay = delay || 0;

        // traditional code
        // if($chk(this.redraw_ticket)) { window.clearTimeout(this.redraw_ticket) };
        // this.redraw_ticket = window.setTimeout(function(){ this.redraw_updateListing(); }.bindAsEventListener(this), timedelay);

        // mootools code
        if ($chk(this.redraw_ticket)) { $clear(this.redraw_ticket) };
        this.redraw_ticket = this.redraw_updateListing.delay(timedelay, this);

    },

    // #####  DONT'T REMOVE  #####
    safari2hatesmissingcommas: function() { }

})
