﻿function checkOrShow(value, cssType){
    var resourceRows = document.getElements('.'+cssType); 
    resourceRows.each(function(row) {
        if(checkboxesSelect)
        {
            var check = row.getElement('.sgnSelector');
            check.checked = value;
        }
        else
        {
            if(value)
                row.removeClass('suppressed');
            else
                row.addClass('suppressed');
        }
    });
}

function checkOrShowResources(cssType)
{
    var value = this.checked;
    checkOrShow(value, cssType);
};

function updateResourcesUponFilter()
{
    var resources = document.getElements('.hdwResource');
    resources.each(function(r){
        var show = true;
        resourceTypeCheckboxes.each(function(item){
            if(!item.box.checked && r.hasClass(item.cssClass)) show = show & false;
        });
        if(show) r.removeClass('suppressed'); else r.addClass('suppressed');
    });  
};

var resourceParentCheckbox;
var resourceTypeCheckboxes;
var checkboxesSelect;

function updateCheckboxesParentChanged() {
    if(resourceParentCheckbox == null) return;    
    var value = resourceParentCheckbox.checked;
    resourceTypeCheckboxes.each(function(checkbox){ checkbox.box.checked=value; });
};

function updateCheckboxesChildChanged() {    
    if(resourceParentCheckbox == null) return;    
    var checked = true;
    resourceTypeCheckboxes.each(function(checkbox){ checked = checked && checkbox.box.checked; });    
    resourceParentCheckbox.checked = checked;
};

function toggleRow(foldingButton)
 {
    // http://www.mooforum.net/help12/possible-bug-event-target-with-t1566.html:
    // "..IE does not automatically extend the native Element object with mootools functions. 
    // the $() function transforms the browser native element to a mootools element.
    foldingButton = $(foldingButton);    
    
    var row = foldingButton.parentNode.parentNode;    
    var child = row.nextSibling;
    var hidden = foldingButton.parentNode.getElementsByTagName('input').item(0);

    if(foldingButton.hasClass('grtExpandButton'))
    {
        // Under IE .removeClass seems not to be defined for the child object (but it is for foldingButton)        
        //child.removeClass('suppressed');
        child.className = child.className.replace(new RegExp('(^|\\s)' + 'suppressed' + '(?:\\s|$)'), '$1');        
        
        foldingButton.removeClass('grtExpandButton');
        foldingButton.addClass('grtCollapseButton');
        foldingButton.innerText='-';
        
        hidden.value = '1';
    }
    else
    {
        // Under IE .addClass seems not to be defined for the child object (but it is for foldingButton)
        //child.addClass('suppressed');
        if (!child.className.clean().contains('suppressed')) child.className = (child.className + ' ' + 'suppressed').clean();
               
        foldingButton.removeClass('grtCollapseButton');
        foldingButton.addClass('grtExpandButton');
        foldingButton.innerText='+';       
        
        hidden.value = '';
    }
};

function liteGridCollapseAll(event)
{ 
    var mooEvent = null;
    if(event!=null) mooEvent = new Event(event);

    var foldingButtons = document.getElements('.grtCollapseButton');
    foldingButtons.each(function(foldingButton){ toggleRow(foldingButton); });

    // prevent default action
    if(mooEvent != null) mooEvent.preventDefault();       
}

function liteGridExpandAll(event)
{
    var mooEvent = null;
    if(event!=null) mooEvent = new Event(event);


    var foldingButtons = document.getElements('.grtExpandButton');
    foldingButtons.each(function(foldingButton){ toggleRow(foldingButton); });

    // prevent default action
    if(mooEvent != null) mooEvent.preventDefault();
}

function liteGridSelectAll(event)
{ 
    var mooEvent = null;
    if(event!=null) mooEvent = new Event(event);

    var deviceSelectors = document.getElements('tr.hdwDevice td input.sgnSelector');
    deviceSelectors.each(function(selector){
        selector.checked = true;
    });
    
    var rows = document.getElements('.hdwResource');
    rows.each(function(row){ 
        if(!row.hasClass('suppressed')) {
            var checkbox = row.getElement('.sgnSelector');
            checkbox.checked = true;
        }        
    });

    // prevent default action
    if(mooEvent != null) mooEvent.preventDefault();       
}

function liteGridUnselectAll(event)
{ 
    var mooEvent = null;
    if(event!=null) mooEvent = new Event(event);

    var deviceSelectors = document.getElements('tr.hdwDevice td input.sgnSelector');
    deviceSelectors.each(function(selector){
        selector.checked = false;
    });
    
    var rows = document.getElements('.hdwResource');
    rows.each(function(row){        
        var checkbox = row.getElement('.sgnSelector');
        checkbox.checked = false;        
    });

    // prevent default action
    if(mooEvent != null) mooEvent.preventDefault();       
}

function liteGridClearFilter(event)
{
    var mooEvent = null;
    if(event!=null) mooEvent = new Event(event);

   if(!checkboxesSelect){
        if(resourceParentCheckbox != null) resourceParentCheckbox.checked = true;
        resourceTypeCheckboxes.each(function(checkbox){
            checkbox.box.checked = true;
        });
    }
    
    updateResourcesUponFilter();
//    resourceTypeCheckboxes.each(function(checkbox){    
//        checkOrShow(true, checkbox.cssClass);
//    });

    // prevent default action
    if(mooEvent != null) mooEvent.preventDefault();     
}
    
window.addEvent('domready',
    function()
    {
        if (document.getElement('.wkaToolbarArea a.watGridExpandAll')) { document.getElement('.wkaToolbarArea a.watGridExpandAll').addEvent('click', liteGridExpandAll.bindWithEvent(this)); }
        if (document.getElement('.wkaToolbarArea a.watGridCollapseAll')) { document.getElement('.wkaToolbarArea a.watGridCollapseAll').addEvent('click', liteGridCollapseAll.bindWithEvent(this)); }
        if (document.getElement('.wkaToolbarArea a.watSelectall')) { document.getElement('.wkaToolbarArea a.watSelectall').addEvent('click', liteGridSelectAll.bindWithEvent(this)); }
        if (document.getElement('.wkaToolbarArea a.watUnselectall')) { document.getElement('.wkaToolbarArea a.watUnselectall').addEvent('click', liteGridUnselectAll.bindWithEvent(this)); }        
        if (document.getElement('.wkaToolbarArea a.watGridClearFilter')) { document.getElement('.wkaToolbarArea a.watGridClearFilter').addEvent('click', liteGridClearFilter.bindWithEvent(this)); }
             
        resourceParentCheckbox = document.getElement('#chkResources');
        
        var temp = 
            [
                {box: document.getElement('#chkAnalogInputs'), cssClass: 'hdwResAnalog'},  
                {box: document.getElement('#chkDigitalInputs'), cssClass: 'hdwResDigital'},  
                {box: document.getElement('#chkStates'), cssClass: 'hdwResState'},  
                {box: document.getElement('#chkAlarms'), cssClass: 'hdwResAlarm'}
            ];        
        resourceTypeCheckboxes = new Array();
        temp.each(function(item){
            if(item.box != null) resourceTypeCheckboxes.push(item);
        });
                                  
        if(resourceParentCheckbox != null) {
            resourceParentCheckbox.addEvent('click', checkOrShowResources.pass('hdwResource', resourceParentCheckbox));
            resourceParentCheckbox.addEvent('click', updateCheckboxesParentChanged.pass(resourceParentCheckbox));
        }
        
        resourceTypeCheckboxes.each(function(checkbox){          
            checkbox.box.addEvent('click', checkOrShowResources.pass(checkbox.cssClass, checkbox.box));
            checkbox.box.addEvent('click', updateCheckboxesChildChanged.pass(checkbox.box));
        });
        
        //liteGridClearFilter(null);
        updateResourcesUponFilter();
    });

var liteGridNetworkTable = new Class({

    initialize: function() {

        this.boxWrapper = document.getElement('div.wrpLiteGridNetTable');

        this.addControllers();
        this.addInstruments();

        if(this.boxWrapper != null) this.boxWrapper.addEvent('click', this.interact_bubbleClick.bindWithEvent(this));
    },

    addControllers: function() {      
    },

    addInstruments: function() {

        this.rowsInterfaces = this.getLiteGrid_rows('hdwInterface');
        this.rowsDevices = this.getLiteGrid_rows('hdwDevice');
        this.rowsResources = this.getLiteGrid_rows('hdwResource');

        this.chkboxSelectors = [];
        this.filterChkbox = [];
        var chkAnalog = document.getElement('input#chkAnalogInputs');
        if (chkAnalog != null) this.filterChkbox.push(chkAnalog);

        var chkDigital = document.getElement('input#chkDigitalInputs');
        if (chkDigital != null) this.filterChkbox.push(chkDigital);

        var chkStates = document.getElement('input#chkStates');
        if (chkStates != null) this.filterChkbox.push(chkStates);

        var chkAlarms = document.getElement('input#chkAlarms');
        if (chkAlarms != null) this.filterChkbox.push(chkAlarms);

        this.setLiteGrid_rowsRelations('ifc', this.rowsInterfaces);
        this.setLiteGrid_rowsRelations('dev', this.rowsDevices);
        this.setLiteGrid_rowsRelations('res', this.rowsResources);

    },

    getLiteGrid_rows: function(knd) {
        if(this.boxWrapper != null) {
            return this.boxWrapper.getElements('tr.' + knd);
        } else {
            return [];
        }
    },

    setLiteGrid_rowsRelations: function(kind, rows) {

        var cknd = kind;

        rows.each(function(crw) {

            var crwchk = crw.getElement('input.sgnSelector');
            if (crwchk) {
                crw.Selector = crwchk;
                crwchk.parent = crw;
                this.chkboxSelectors.push(crwchk);
            }       
        }, this);

    },


    redraw_updateSelections: function() {      

        // set row selection
        if (this.rowsInterfaces) { this.rowsInterfaces.each(function(crw) { crw.conditionalClass('selected', (crw.selector && crw.selector.checked)); }, this); }
        if (this.rowsDevices) { this.rowsDevices.each(function(crw) { crw.conditionalClass('selected', (crw.selector && crw.selector.checked)); }, this); }
        if (this.rowsResources) { this.rowsResources.each(function(crw) { crw.conditionalClass('selected', (crw.selector && crw.selector.checked)); }, this); }

    },


    interact_bubbleClick: function(event) {

        // init moo event handling
        var mooEvent = new Event(event);
        var ccobj = $(mooEvent.target);

        var isChecked = ccobj.checked; // checking action

        if (ccobj.hasClass('sgnSelector')) {
            var crow = ccobj.parent;

            // From device to its resources
            if (crow.hasClass('hdwDevice')) {
                var deviceId = crow.id;
                //esempio: <tr id="ifc0.00:01.INP40000-1" class="hdwResource"> ..</tr>
                document.getElements('tr.hdwResource').each(function(res) {
                    if (res.Selector &&
                    //esempio: <tr id="ifc0.00:01" class="hdwDevice" >..</tr>
                        res.id.substring(0, res.id.lastIndexOf('.')) == deviceId) {
                        res.Selector.checked = isChecked;
                    }
                });
            }

            // From resources to parent device
            if (crow.hasClass('hdwResource')) {
                //esempio: <tr id="ifc0.00:01.INP40000-1" class="hdwResource"> ..</tr>
                var deviceId = crow.id.substring(0, crow.id.lastIndexOf('.'));
                var glbbol = false;
                //console.log('interact_bubbleClick parent is ' + ccobj.parent.getFirstParentByTag('tr').id);
                //console.log('interact_bubbleClick parent is ' + ccobj.parent.getFirstParentByTag('tr').id);
                // Filter of array of all resouces
                var resFiltered = this.rowsResources.filter(function(item, index) {
                    return item.id.substring(0, item.id.lastIndexOf('.')) == deviceId;
                });
                // Calcolate resources checked status
                resFiltered.each(function(res) {
                    if (res.Selector) {
                        glbbol = glbbol || res.Selector.checked;
                    }
                });

                var crwparent = $(crow.id.substring(0, crow.id.lastIndexOf('.')));
                crwparent.Selector.checked = glbbol;
            }

        }
        // stop propagation
        mooEvent.stopPropagation();
    },

    onselect_checkParent: function(row, recursive) {

        if (!row.parent) return;
        var gbol = false;
        row.parent.childlist.each(function(csr) {
            if (csr.selector) {
                gbol = gbol || csr.selector.checked;
            }
        });

        if (row.parent.selector && row.parent.selector.checked != gbol) {
            row.parent.selector.checked = gbol;
            //row.parent.selector.fireEvent('change'); 
        }
        if (recursive) {
            this.onselect_checkParent(row.parent, true);
        }
    },

    onselect_checkChilds: function(row, recursive) {

        if (!row.childlist) return;

        row.childlist.each(function(ccr) {
            if (ccr.selector && !ccr.suppressed && !ccr.selector.disabled && ccr.selector.checked != row.selector.checked) {
                ccr.selector.checked = row.selector.checked;
                //ccr.selector.fireEvent('change'); 
            }
            if (recursive) {
                this.onselect_checkChilds(ccr, true);
            }
        }, this);

    },

    // #####  DONT'T REMOVE  #####
    safari2hatesmissingcommas: function() { }
}) // liteGridNetworkTable

